/*-------------------------------------------------------------------------+
| Copyright 2016 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.moea.model.predefined.impl;

import static org.fortiss.af3.exploration.util.CommonExplorationTagetModelElementFactory.createComponentDislocationConstraint;

import java.util.Collection;

import org.eclipse.emf.common.util.EList;
import org.fortiss.af3.component.model.Component;
import org.fortiss.af3.exploration.model.location.ComponentDislocationConstraint;
import org.fortiss.af3.exploration.moea.model.predefined.ComponentMultiDislocationConstraint;
import org.fortiss.af3.platform.model.ExecutionUnit;

/**
 * Static method implementations for {@link ComponentMultiDislocationConstraint}s.
 * 
 * @author diewald
 */
public class ComponentMultiDislocationConstraintStaticImpl {
	/**
	 * Static implementation of the
	 * {@link ComponentMultiDislocationConstraint#setComponentMultiDislocations(Component, EList)}
	 * method.
	 */
	public static void setComponentMultiDislocations(ComponentMultiDislocationConstraint constr,
			Component comp, Collection<ExecutionUnit> execUnits) {
		if(constr == null) {
			return;
		}
		constr.getSingleLocationConstraints().clear();
		for(ExecutionUnit singleExecUnit : execUnits) {
			// LocationConstraint<Component, Dislocation, ExecutionUnit>
			ComponentDislocationConstraint allocConstr =
					createComponentDislocationConstraint(comp, singleExecUnit);
			constr.getSingleLocationConstraints().add(allocConstr);
		}
	}
}
